#ifndef _FBO_H_
#define _FBO_H_

// 1 depth, 1 frame
struct FBO1 {
 GLuint id,depth,tex_id;
};

// 0 depth, 3 frame
struct FBO2 {
 GLuint id,tex_id[3];
};

// trieda premennych a funkcii pre pracu s OpenGL FBO
class CFBO {
public:
 CFBO();  // konstruktor
 ~CFBO(); // destruktor

 int init(void);        // inicializacia FBO
 void cancel(void);     // zrusenie FBO
 void drawfbo1_attachment(void);  // vykreslenie obsahu FBO1
 void drawfbo2_attachment(int N); // vykreslenie obsahu FBO2
 void draw(void); // vykreslenie objektu FBO

 GLuint getfbo1(void) { return(f1.id); }
 GLuint getfbo2(void) { return(f2.id); }
 GLuint getfbo1_tex_id(void) { return(f1.tex_id); }
 GLuint getfbo2_tex_id(int N) { return(f2.tex_id[N]); }
private:
 FBO1 f1; // FBO1 pre scr_w,scr_h
 FBO2 f2; // FBO2 pre scr_w2,scr_h2

 GLenum ret; // pomocne premenne
 bool created;

 float v[18]; // 3x6 vrcholov stvoruholnika
 float t[12]; // 2x6 texturovacich suradnic
};

#endif
